using apiLOL;
using apiLOL.Controllers;
using Microsoft.AspNetCore.Mvc;
using StubLib;

namespace TestUnitaire
{
	public class TestAPILol
	{
		[Theory]
		[InlineData("Aatrox", "Aatrox est un champion de League of Legends")]
		[InlineData("Ahri", "Ahri est un champion de League of Legends")]
		[InlineData("Akali", "Akali est un champion de League of Legends")]
		public async Task TestPostChampion(string name, string bio)
		{
			// Arrange
			var data = new StubData();
			var controller = new ControllerChampions(new StubData());
			var champDTO = new ChampionDTO(name, bio);

			// Act
			var nbInListBefore = data.ChampionsMgr.GetNbItems().Result;
			var result = await controller.Post(champDTO);
			var nbInListAfter = data.ChampionsMgr.GetNbItems().Result;

			// Assert
			// IS the champion added to the list, number of champions in the list + 1
			Assert.Equal(nbInListBefore + 1, nbInListAfter);
		}


		[Theory]
		[InlineData("Aatrox", "Aatrox est un champion de League of Legends")]
		[InlineData("Ahri", "Ahri est un champion de League of Legends")]
		[InlineData("Akali", "Akali est un champion de League of Legends")]
		public async Task TestGetChampion(string name, string bio)
		{
			// Arrange
			var data = new StubData();
			var controller = new ControllerChampions(new StubData());
			var champDTO = new ChampionDTO(name, bio);

			// Act
			// Call method POST to add a champion
			var result = await controller.Post(champDTO);
			// Call method GET to get the champion
			var resultGet = await controller.GetChampion(name);

			// Assert
			// IS the champion added to the list, number of champions in the list + 1
			Assert.Equal(name, champDTO.Name);
			Assert.Equal(bio, champDTO.Bio);
		}
	}
}